com.ihr.xbrl.om.taxonomy

## Enum XBRLItem.PeriodType

- java.lang.Object
- - java.lang.Enum<XBRLItem.PeriodType>
  - - com.ihr.xbrl.om.taxonomy.XBRLItem.PeriodType

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<XBRLItem.PeriodType>
  Enclosing class:
    XBRLItem

      public static enum XBRLItem.PeriodType
      extends java.lang.Enum<XBRLItem.PeriodType>

  Enumeration defining the content of the xbrli:periodType attribute but also used to report the type of a XBRLPeriod object inside an XBRLContext. Note that FOREVER is an XBRLPeriod type that corresponds to an item whose periodType is DURATION.
  Since:
    2.6.10
  Author:
    Ignacio

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `DURATION` The period type is DURATION.
    `FOREVER` This is used only for XBRLPeriod objects inside XBRLContext objects.
    `INSTANT` The period type is INSTANT.
    `UNDEFINED_PERIOD_TYPE` The concept has no period type defined.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static XBRLItem.PeriodType` | `getPeriodType(java.lang.String periodType)` Returns the PeriodType enumerated value of the period type in the string.
    `static java.lang.String` | `getPeriodType(XBRLItem.PeriodType periodType)` Returns a string representation of the period type received as a parameter.
    `static java.lang.String` | `getPeriodTypeLocaliced(XBRLItem.PeriodType periodType)` Returns a string representation of the period type received as a parameter.
    `static XBRLItem.PeriodType` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static XBRLItem.PeriodType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### UNDEFINED_PERIOD_TYPE

          public static final XBRLItem.PeriodType UNDEFINED_PERIOD_TYPE

      The concept has no period type defined. This is not allowed by XBRL because every Item MUST be either of INSTANT or DURATION type.

    - #### INSTANT

          public static final XBRLItem.PeriodType INSTANT

      The period type is INSTANT.

    - #### DURATION

          public static final XBRLItem.PeriodType DURATION

      The period type is DURATION.

    - #### FOREVER

          public static final XBRLItem.PeriodType FOREVER

      This is used only for XBRLPeriod objects inside XBRLContext objects. The corresponding type in the concept definition is DURATION

  - ### Method Detail

    - #### values

          public static XBRLItem.PeriodType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (XBRLItem.PeriodType c : XBRLItem.PeriodType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static XBRLItem.PeriodType valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getPeriodType

          public static XBRLItem.PeriodType getPeriodType(java.lang.String periodType)

      Returns the PeriodType enumerated value of the period type in the string. This method returns INSTANT if the parameter is "instant", DURATION if the parameter is "duration", FOREVER if the parameter is "forever" and UNDEFINED_PERIOD_TYPE in any other case.
      Parameters:
        `periodType` - the period type
      Returns:
        PeriodType

    - #### getPeriodType

          public static java.lang.String getPeriodType(XBRLItem.PeriodType periodType)

      Returns a string representation of the period type received as a parameter. Note: this functions only recognizes INSTANT and DURATION PeriodTypes. the value null is returned in any other case.
      Parameters:
        `periodType` - the period type
      Returns:
        String representation of the period type if the period type is INSTANT or DURATION only

    - #### getPeriodTypeLocaliced

          public static java.lang.String getPeriodTypeLocaliced(XBRLItem.PeriodType periodType)

      Returns a string representation of the period type received as a parameter. Note: this functions only recognizes INSTANT and DURATION PeriodTypes. the value null is returned in any other case.
      Parameters:
        `periodType` - the period type
      Returns:
        String representation of the period type if the period type is INSTANT or DURATION only